/usr/sbin/grub-install is in grub 0.97-29ubuntu66.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 | #! /bin/sh
# Install GRUB on your drive.
# Copyright (C) 1999,2000,2001,2002,2003,2004 Free Software Foundation, Inc.
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Initialize some variables.
prefix=/usr
exec_prefix=${prefix}
sbindir=${exec_prefix}/sbin
libdir=${exec_prefix}/lib
PACKAGE=grub
VERSION=0.97
host_cpu=x86_64
host_os=linux-gnu
host_vendor=pc
pkglibdir=${libdir}/${PACKAGE}/${host_cpu}-${host_vendor}
grub_shell=${sbindir}/grub
grub_set_default=${sbindir}/grub-set-default
log_file=/tmp/grub-install.log.$$
img_file=/tmp/grub-install.img.$$
rootdir=
grub_prefix=/boot/grub
install_device=
no_floppy=
force_lba=
recheck=no
debug=no
# look for secure tempfile creation wrappers on this platform
if test -x /bin/tempfile; then
mklog="/bin/tempfile --prefix=grub"
mkimg="/bin/tempfile --prefix=grub"
elif test -x /bin/mktemp; then
mklog="/bin/mktemp /tmp/grub-install.log.XXXXXX"
mkimg="/bin/mktemp /tmp/grub-install.img.XXXXXX"
else
mklog=""
mkimg=""
fi
# Usage: usage
# Print the usage.
usage () {
cat <<EOF
Usage: grub-install [OPTION] install_device
Install GRUB on your drive.
-h, --help print this message and exit
-v, --version print the version information and exit
--root-directory=DIR install GRUB images under the directory DIR
instead of the root directory
--grub-shell=FILE use FILE as the grub shell
--no-floppy do not probe any floppy drive
--force-lba force GRUB to use LBA mode even for a buggy
BIOS
--recheck probe a device map even if it already exists
INSTALL_DEVICE can be a GRUB device name or a system device filename.
grub-install copies GRUB images into the DIR/boot directory specfied by
--root-directory, and uses the grub shell to install grub into the boot
sector.
Report bugs to <bug-grub@gnu.org>.
EOF
}
# Usage: getraid_mdadm mddevice
# Routine to find a physical device from an md device
# If found, the first grub BIOS device (from device.map) is returned
# If no BIOS drives match the RAID devices, the first device returned
# from mdadm -D is returned
getraid_mdadm() {
device=$1
mdadm=$(mdadm -D "$device") || {
echo "$PROG: mdadm -D $device failed" >&2
exit 1
}
eval "$(
echo "$mdadm" | awk '
$1 == "Number" && $2 == "Major" { start = 1; next }
$1 == "UUID" { print "uuid=" $3; start = 0; next }
!start { next }
$2 == 0 && $3 == 0 { next }
{ devices = devices "\n" $NF }
END { print "devices='\''" devices "'\''" }
'
)"
# Convert RAID devices list into a list of disks
tmp_disks=`echo "$devices" | sed -e 's%\(\(v\|s\|h\|xv\)d[a-z]\)[0-9]*$%\1%' \
-e 's%\(d[0-9]*\)p[0-9]*$%\1%' \
-e 's%\(fd[0-9]*\)$%\1%' \
-e 's%/part[0-9]*$%/disc%' \
-e 's%\(c[0-7]d[0-9]*\).*$%\1%' \
-e '/^$/d' |
sed -n '1h;2,$H;${g;s/\n/|/g;p}'`
# Find first BIOS disk that's a member of the RAID array
# Default to first RAID member if no tmp_disks are BIOS devices
set -- `egrep $tmp_disks $device_map | \
sort | \
sed -n 1p `
device=${2:-${tmp_disks%%|*}}
# Return first partition on BIOS disk that's part of the RAID
echo "$devices" | \
sed -n "\:${device}:p" | \
sed -n 1p
}
# Usage: convert os_device
# Convert an OS device to the corresponding GRUB drive.
# This part is OS-specific.
convert () {
# First, check if the device file exists.
if test -e "$1"; then
:
else
echo "$1: Not found or not a block device." 1>&2
exit 1
fi
# Break the device name into the disk part and the partition part.
case "$host_os" in
linux*)
# Find an actual physical device if we're passed a RAID device
case $1 in
/dev/md*) set -- `getraid_mdadm $1`
esac
tmp_disk=`echo "$1" | sed -e 's%\(\(v\|s\|h\|xv\)d[a-z]\)[0-9]*$%\1%' \
-e 's%\(d[0-9]*\)p[0-9]*$%\1%' \
-e 's%\(fd[0-9]*\)$%\1%' \
-e 's%/part[0-9]*$%/disc%' \
-e 's%\(c[0-7]d[0-9]*\).*$%\1%' \
-e 's%\(e[0-9]\.[0-9]*\).*$%\1%'`
tmp_part=`echo "$1" | sed -e 's%.*/\(v\|s\|h\|xv\)d[a-z]\([0-9]*\)$%\2%' \
-e 's%.*d[0-9]*p%%' \
-e 's%.*/fd[0-9]*$%%' \
-e 's%.*/floppy/[0-9]*$%%' \
-e 's%.*/\(disc\|part\([0-9]*\)\)$%\2%' \
-e 's%.*c[0-7]d[0-9]*p*%%' \
-e 's%.*e[0-9]\.[0-9]*p%%' \
-e 's%.*e[0-9]\.[0-9]*\$%%'`
;;
gnu*)
tmp_disk=`echo "$1" | sed 's%\([vsh]d[0-9]*\).*%\1%'`
tmp_part=`echo "$1" | sed "s%$tmp_disk%%"` ;;
freebsd* | kfreebsd*-gnu)
tmp_disk=`echo "$1" | sed 's%r\{0,1\}\([saw]d[0-9]*\).*$%\1%' \
| sed 's%r\{0,1\}\(da[0-9]*\).*$%\1%'`
tmp_part=`echo "$1" \
| sed "s%.*/r\{0,1\}[saw]d[0-9]\(s[0-9]*[a-h]\)%\1%" \
| sed "s%.*/r\{0,1\}da[0-9]\(s[0-9]*[a-h]\)%\1%"`
;;
netbsd* | knetbsd*-gnu)
tmp_disk=`echo "$1" | sed 's%r\{0,1\}\([sw]d[0-9]*\).*$%r\1d%' \
| sed 's%r\{0,1\}\(fd[0-9]*\).*$%r\1a%'`
tmp_part=`echo "$1" \
| sed "s%.*/r\{0,1\}[sw]d[0-9]\([abe-p]\)%\1%"`
;;
*)
echo "grub-install does not support your OS yet." 1>&2
exit 1 ;;
esac
# Get the drive name.
tmp_drive=`grep -v '^#' $device_map | grep "$tmp_disk *$" \
| sed 's%.*\(([hf]d[0-9][a-z0-9,]*)\).*%\1%'`
# If not found, print an error message and exit.
if test "x$tmp_drive" = x; then
echo "$1 does not have any corresponding BIOS drive." 1>&2
# If /boot is on a RAID device, provide more information
if mdadm --detail "$bootdir_device" >/dev/null 2>&1; then
echo "You can run grub-install on your RAID device [$bootdir_device]," 1>&2
echo "or you can define [$1] in [$device_map]." 1>&2
fi
exit 1
fi
if test "x$tmp_part" != x; then
# If a partition is specified, we need to translate it into the
# GRUB's syntax.
case "$host_os" in
linux*)
echo "$tmp_drive" | sed "s%)$%,`expr $tmp_part - 1`)%" ;;
gnu*)
if echo $tmp_part | grep "^s" >/dev/null; then
tmp_pc_slice=`echo $tmp_part \
| sed "s%s\([0-9]*\)[a-z]*$%\1%"`
tmp_drive=`echo "$tmp_drive" \
| sed "s%)%,\`expr "$tmp_pc_slice" - 1\`)%"`
fi
if echo $tmp_part | grep "[a-z]$" >/dev/null; then
tmp_bsd_partition=`echo "$tmp_part" \
| sed "s%[^a-z]*\([a-z]\)$%\1%"`
tmp_drive=`echo "$tmp_drive" \
| sed "s%)%,$tmp_bsd_partition)%"`
fi
echo "$tmp_drive" ;;
freebsd* | kfreebsd*-gnu)
if echo $tmp_part | grep "^s" >/dev/null; then
tmp_pc_slice=`echo $tmp_part \
| sed "s%s\([0-9]*\)[a-h]*$%\1%"`
tmp_drive=`echo "$tmp_drive" \
| sed "s%)%,\`expr "$tmp_pc_slice" - 1\`)%"`
fi
if echo $tmp_part | grep "[a-h]$" >/dev/null; then
tmp_bsd_partition=`echo "$tmp_part" \
| sed "s%s\{0,1\}[0-9]*\([a-h]\)$%\1%"`
tmp_drive=`echo "$tmp_drive" \
| sed "s%)%,$tmp_bsd_partition)%"`
fi
echo "$tmp_drive" ;;
netbsd* | knetbsd*-gnu)
if echo $tmp_part | grep "^[abe-p]$" >/dev/null; then
tmp_bsd_partition=`echo "$tmp_part" \
| sed "s%\([a-p]\)$%\1%"`
tmp_drive=`echo "$tmp_drive" \
| sed "s%)%,$tmp_bsd_partition)%"`
fi
echo "$tmp_drive" ;;
esac
else
# If no partition is specified, just print the drive name.
echo "$tmp_drive"
fi
}
# Usage: resolve_symlink file
# Find the real file/device that file points at
resolve_symlink () {
tmp_fname=$1
# Resolve symlinks
while test -L $tmp_fname; do
tmp_new_fname=`ls -al $tmp_fname | sed -n 's%.*-> \(.*\)%\1%p'`
if test -z "$tmp_new_fname"; then
echo "Unrecognized ls output" 2>&1
exit 1
fi
# Convert relative symlinks
case $tmp_new_fname in
/*) tmp_fname="$tmp_new_fname"
;;
*) tmp_fname="`echo $tmp_fname | sed 's%/[^/]*$%%'`/$tmp_new_fname"
;;
esac
done
echo "$tmp_fname"
}
# Usage: find_device file
# Find block device on which the file resides.
find_device () {
# For now, this uses the program `df' to get the device name, but is
# this really portable?
tmp_fname=`df $1/ | sed -n 's%.*\(/dev/[^ ]*\).*%\1%p'`
if test -z "$tmp_fname"; then
echo "Could not find device for $1" 2>&1
exit 1
fi
tmp_fname=`resolve_symlink $tmp_fname`
echo "$tmp_fname"
}
# Check the arguments.
for option in "$@"; do
case "$option" in
-h | --help)
usage
exit 0 ;;
-v | --version)
echo "grub-install (GNU GRUB ${VERSION})"
exit 0 ;;
--root-directory=*)
rootdir=`echo "$option" | sed 's/--root-directory=//'` ;;
--grub-shell=*)
grub_shell=`echo "$option" | sed 's/--grub-shell=//'` ;;
--no-floppy)
no_floppy="--no-floppy" ;;
--force-lba)
force_lba="--force-lba" ;;
--recheck)
recheck=yes ;;
# This is an undocumented feature...
--debug)
debug=yes ;;
-*)
echo "Unrecognized option \`$option'" 1>&2
usage
exit 1
;;
*)
if test "x$install_device" != x; then
echo "More than one install_devices?" 1>&2
usage
exit 1
fi
install_device="${option}" ;;
esac
done
if test "x$install_device" = x; then
echo "install_device not specified." 1>&2
usage
exit 1
fi
# If the debugging feature is enabled, print commands.
if test $debug = yes; then
set -x
fi
# Initialize these directories here, since ROOTDIR was initialized.
case "$host_os" in
netbsd* | openbsd*)
# Because /boot is used for the boot block in NetBSD and OpenBSD, use /grub
# instead of /boot/grub.
grub_prefix=/grub
bootdir=${rootdir}
;;
*)
# Use /boot/grub by default.
bootdir=${rootdir}/boot
;;
esac
grubdir=${bootdir}/grub
device_map=${grubdir}/device.map
# Check if GRUB is installed.
# This is necessary, because the user can specify "grub --read-only".
set $grub_shell dummy
if test -f "$1"; then
:
else
echo "$1: Not found." 1>&2
exit 1
fi
if test -f "$pkglibdir/stage1"; then
:
else
echo "${pkglibdir}/stage1: Not found." 1>&2
exit 1
fi
if test -f "$pkglibdir/stage2"; then
:
else
echo "${pkglibdir}/stage2: Not found." 1>&2
exit 1
fi
# Don't check for *stage1_5, because it is not fatal even if any
# Stage 1.5 does not exist.
# Create the GRUB directory if it is not present.
test -d "$bootdir" || mkdir "$bootdir" || exit 1
test -d "$grubdir" || mkdir "$grubdir" || exit 1
# If --recheck is specified, remove the device map, if present.
if test $recheck = yes; then
rm -f $device_map
fi
# Create the device map file if it is not present.
if test -f "$device_map"; then
:
else
# Create a safe temporary file.
test -n "$mklog" && log_file=`$mklog`
# Before all invocations of the grub shell, call sync to make sure
# the raw device is in sync with any bufferring in filesystems.
sync
$grub_shell --batch $no_floppy --device-map=$device_map <<EOF >$log_file
quit
EOF
if grep "Error [0-9]*: " $log_file >/dev/null; then
cat $log_file 1>&2
exit 1
fi
rm -f $log_file
fi
# Make sure that there is no duplicated entry.
tmp=`sed -n '/^([fh]d[0-9]*)/s/\(^(.*)\).*/\1/p' $device_map \
| sort | uniq -d | sed -n 1p`
if test -n "$tmp"; then
echo "The drive $tmp is defined multiple times in the device map $device_map" 1>&2
exit 1
fi
# Get the root drive.
root_device=`find_device ${rootdir}`
bootdir_device=`find_device ${bootdir}`
# Check for INSTALL_DEVICE.
case "$install_device" in
/dev/*)
install_device=`resolve_symlink "$install_device"`
install_drive=`convert "$install_device"`
# I don't know why, but some shells wouldn't die if exit is
# called in a function.
if test "x$install_drive" = x; then
exit 1
fi ;;
\([hf]d[0-9]*\))
install_drive="$install_device" ;;
[hf]d[0-9]*)
# The GRUB format with no parenthesis.
install_drive="($install_device)" ;;
*)
echo "Format of install_device not recognized." 1>&2
usage
exit 1 ;;
esac
# Check if the boot directory is in the same device as the root directory.
if test "x$root_device" != "x$bootdir_device"; then
# Perhaps the user has a separate boot partition.
root_device=$bootdir_device
grub_prefix="/grub"
fi
# Convert the root device to a GRUB drive.
root_drive=`convert "$root_device"`
if test "x$root_drive" = x; then
exit 1
fi
# Check if the root directory exists in the same device as the grub
# directory.
grubdir_device=`find_device ${grubdir}`
if test "x$grubdir_device" != "x$root_device"; then
# For now, cannot deal with this situation.
cat <<EOF 1>&2
You must set the root directory by the option --root-directory, because
$grubdir does not exist in the root device $root_device.
EOF
exit 1
fi
# Copy the GRUB images to the GRUB directory.
for file in ${grubdir}/stage1 ${grubdir}/stage2 ${grubdir}/*stage1_5; do
rm -f $file || exit 1
done
for file in \
${pkglibdir}/stage1 ${pkglibdir}/stage2 ${pkglibdir}/*stage1_5; do
cp -f $file ${grubdir} || exit 1
done
# Make a default file.
${grub_set_default} --root-directory=${rootdir} default
# Make sure that GRUB reads the same images as the host OS.
test -n "$mkimg" && img_file=`$mkimg`
test -n "$mklog" && log_file=`$mklog`
# GRUB will try to verify that stage2 is accessible using its own
# filesystem drivers. Make sure it's committed to disk.
sync
# On XFS, sync() is not enough.
if [ `grub-probe -t fs ${grubdir}` = "xfs" ] ; then
xfs_freeze -f ${grubdir} && xfs_freeze -u ${grubdir}
# We don't have set -e. If xfs_freeze failed, it's worth trying anyway,
# maybe we're lucky.
fi
for file in ${grubdir}/stage1 ${grubdir}/stage2 ${grubdir}/*stage1_5; do
count=5
tmp=`echo $file | sed "s|^${grubdir}|${grub_prefix}|"`
while test $count -gt 0; do
$grub_shell --batch $no_floppy --device-map=$device_map <<EOF >$log_file
dump ${root_drive}${tmp} ${img_file}
quit
EOF
if grep "Error [0-9]*: " $log_file >/dev/null; then
:
elif cmp $file $img_file >/dev/null; then
break
fi
sleep 1
count=`expr $count - 1`
done
if test $count -eq 0; then
echo "The file $file not read correctly." 1>&2
exit 1
fi
done
rm -f $img_file
rm -f $log_file
# Create a safe temporary file.
test -n "$mklog" && log_file=`$mklog`
# Before all invocations of the grub shell, call sync to make sure
# the raw device is in sync with any bufferring in filesystems.
sync
# Now perform the installation.
if echo "$install_device" | grep -qs "^/dev/md[0-9]" 2>/dev/null; then
# installing to an md device; write an MBR to each disk in the RAID
echo -n > $log_file
for disk in $(mdadm --detail "$install_device" 2>/dev/null | \
grep " active sync " 2>/dev/null | \
sed "s/^.* active sync\s*//" 2>/dev/null \
); do
dev=$(echo "$disk" | sed "s/[0-9]\+$//")
bootpart=${disk#$dev}
grubroot=$(($bootpart-1))
hddev=$(echo "$install_drive" | sed "s/[()]//g" | sed "s/,.*//")
echo "Installing GRUB to $dev as ($hddev,$grubroot)..."
$grub_shell --device-map=/dev/null <<EOF >>$log_file
device ($hddev) $dev
root ($hddev,$grubroot)
setup $force_lba --stage2=$grubdir/stage2 --prefix=$grub_prefix ($hddev)
quit
EOF
done
else
# traditional case, normal grub installation
echo "Installing GRUB to $install_device as $install_drive..."
$grub_shell --batch $no_floppy --device-map=$device_map <<EOF >$log_file
root $root_drive
setup $force_lba --stage2=$grubdir/stage2 --prefix=$grub_prefix $install_drive
quit
EOF
fi
if grep "Error [0-9]*: " $log_file >/dev/null || test $debug = yes; then
cat $log_file 1>&2
exit 1
fi
dpkg-query -W -f '${Version}\n' grub > ${grubdir}/installed-version
rm -f $log_file
echo "Installation finished. No error reported."
if echo "$install_device" | grep -qs "^/dev/md[0-9]" 2>/dev/null; then
# Displaying device.map when installing to a RAID device is misleading
exit 0
fi
# Prompt the user to check if the device map is correct.
echo "This is the contents of the device map $device_map."
echo "Check if this is correct or not. If any of the lines is incorrect,"
echo "fix it and re-run the script \`grub-install'."
echo
cat $device_map
# Bye.
exit 0
|